﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using VisualComponentsLib.Object;

namespace WinForms
{
    public partial class FormForComponents : Form
    {
        List<string> list = new List<string>();
        List<Student> students = new List<Student>();
        public FormForComponents()
        {
            list = new List<string>();
            list.AddRange(new string[] { "вилка", "ложка", "нож" });
            Student student1 = new Student("Бондаренко", "ПИбд-32", "ФИСТ", 3);
            Student student2 = new Student("Алейкин", "РТбд-21", "РТФ", 1);
            Student student3 = new Student("Лексин", "ЛМККбд-43", "ГФ", 4);
            students.Add(student1);
            students.Add(student2);
            students.Add(student3);
            InitializeComponent();
            dropDownList.LoadValues(new List<string>() { "вилочка", "ложечка", "ножик" });
            emailTextBox.Pattern = @"^([\w\.\-]+)@([\w\-]+)((\.(\w){2,3})+)$";
            listBoxObj.SetLayoutInfo("Фамилия *Name* Группа *Group* Факультет *Faculty* Курс *Course*", "*", "*");
            dropDownList.ValueChanged += CustomEventHandler;
        }
        private void CustomEventHandler(object sender, EventArgs e)
        {
            MessageBox.Show("Выбранный элемент изменен");
        }
        private void buttonAdd_Click(object sender, EventArgs e)
        {
            dropDownList.LoadValues(list);
        }

        private void buttonInfo_Click(object sender, EventArgs e)
        {
            labelInfo.Text = dropDownList.SelectedValue;
        }

        private void buttonClear_Click(object sender, EventArgs e)
        {
            dropDownList.Clear();
        }

        private void buttonSetExample_Click(object sender, EventArgs e)
        {
            if (textBoxExample.Text == String.Empty)
            {
                return;
            }
            emailTextBox.setExample(textBoxExample.Text);
        }

        private void buttonShow_Click(object sender, EventArgs e)
        {
            try
            {
                if (emailTextBox.TextBoxValue != null)
                {
                    labelShow.Text = "подходит";
                }
                else labelShow.Text = "не подходит";
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void buttonAddObjects_Click(object sender, EventArgs e)
        {
            listBoxObj.AddInListBox<Student>(students);
        }

        private void buttonShowItem_Click(object sender, EventArgs e)
        {
            string str = listBoxObj.GetObjectFromStr<Student>().Name + " " + listBoxObj.GetObjectFromStr<Student>().Group + " " + listBoxObj.GetObjectFromStr<Student>().Faculty + " " + listBoxObj.GetObjectFromStr<Student>().Course;
            labelShowInput.Text = str;
        }
    }
}
